package com.sun.xml.internal.ws.spi.db;

import java.io.InputStream;
import javax.xml.transform.Source;
import com.sun.istack.internal.Nullable;
import javax.xml.bind.attachment.AttachmentUnmarshaller;
import javax.xml.stream.XMLStreamReader;
import javax.xml.transform.Result;
import org.xml.sax.ContentHandler;
import org.w3c.dom.Node;
import javax.xml.namespace.NamespaceContext;
import java.io.OutputStream;
import javax.xml.bind.JAXBException;
import javax.xml.bind.attachment.AttachmentMarshaller;
import javax.xml.stream.XMLStreamWriter;
import com.sun.istack.internal.NotNull;

public interface XMLBridge<T>
{
    @NotNull
    public abstract BindingContext context();
    
    public abstract void marshal(T p0, XMLStreamWriter p1, AttachmentMarshaller p2) throws JAXBException;
    
    public abstract void marshal(T p0, OutputStream p1, NamespaceContext p2, AttachmentMarshaller p3) throws JAXBException;
    
    public abstract void marshal(T p0, Node p1) throws JAXBException;
    
    public abstract void marshal(T p0, ContentHandler p1, AttachmentMarshaller p2) throws JAXBException;
    
    public abstract void marshal(T p0, Result p1) throws JAXBException;
    
    @NotNull
    public abstract T unmarshal(@NotNull XMLStreamReader p0, @Nullable AttachmentUnmarshaller p1) throws JAXBException;
    
    @NotNull
    public abstract T unmarshal(@NotNull Source p0, @Nullable AttachmentUnmarshaller p1) throws JAXBException;
    
    @NotNull
    public abstract T unmarshal(@NotNull InputStream p0) throws JAXBException;
    
    @NotNull
    public abstract T unmarshal(@NotNull Node p0, @Nullable AttachmentUnmarshaller p1) throws JAXBException;
    
    public abstract TypeInfo getTypeInfo();
    
    public abstract boolean supportOutputStream();
}
